#include "BasicDataTypeSkel.h"
#include "ExtendedDataTypesSkel.h"

#include "SwissRangerRTCData.h"

#include "mesaRangeData.h"

#include "opencv/cvmath/cvmath.h"

#include <fstream>

//BNew, CNew`Ă
#include "ip.h"

#define TRY_COUNT1 5
#define TRY_COUNT2 1

//3p^[̎ʃR[h(icp3d.cpplocateobjectŎgp)
#define BOX_XY 100
#define BOX_YZ 101
#define BOX_XZ 102

//ff[^
typedef struct _model{
	short Model_id;
	short Model_category;

	double wx;
	double wy;
	double wz;

	double height;
	double radius;
} Model;

//茋
typedef struct _estimateparameter{

	int	   id;
	//ʒup
	RTC::Pose3D pose;
	//덷
	double estimate_error;
	int	   effective_points;
	//~ɗp
	double side_correspondence_rate;
	//]l ̐ɗp
	double evaluate_value;
} EstimateParameter;

//Mx臒l
extern float ConfidenceThresh;

extern opencv::cvmath::Matrix<CV_64F> intrinsic, distortion;
extern opencv::cvmath::Matrix<CV_64F> translation, rotation;

extern double final_vertices_x[8];
extern double final_vertices_y[8];
extern double final_vertices_z[8];

extern double final_cylinder_vertices_x[16];
extern double final_cylinder_vertices_y[16];
extern double final_cylinder_vertices_z[16];

extern int large_region_num;
extern int box_count;
extern int cylinder_count;

extern int obj_count;
