#include <opencv/cv.h>
#include <opencv/highgui.h>
#include <stdio.h>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>

#include "opencv/cvmath/cvmath.h"
#include "opencv/cvutil/undistortion.h"

//#include "../../opencv/cvmath/cvmath.h"
#include "SwissRangerRTCData.h"

#include "mesaRangeData.h"
#include "pixel.h"
#include "ip.h"

//fobOp
//#define DEBUG

#define IMAGE_NUM  (1)         // 摜 
//傫ȃLu[Vp^[
/*#define PAT_ROW    (6)          // p^[̍s 
#define PAT_COL    (7)         // p^[̗ 
*/
//ȃLu[Vp^[
/*#define PAT_ROW  (3)
#define PAT_COL  (4)*/
//炢̃Lu[Vp^[
/*#define PAT_ROW  (7)
#define PAT_COL  (10)
#define PAT_SIZE   (PAT_ROW*PAT_COL)
#define ALL_POINTS (IMAGE_NUM*PAT_SIZE)*/
//#define CHESS_SIZE (50.0)       // p^[1}X1ӃTCY[mm] 
//#define CHESS_SIZE (23.0)
//#define CHESS_SIZE(15.0)

//#define max(a,b)            (((a) > (b)) ? (a) : (b))

//@op
#define SurfaceNormalWindowSize	7
#define HalfSurfaceNormalWindowSize	3

extern float Chess_size;
extern int   Pat_row;
extern int   Pat_col;

float CHESS_SIZE;
int PAT_ROW;
int PAT_COL;

int PAT_SIZE;
int ALL_POINTS;

//ϑꂽ3_Qƌʒl摜
point RangeDatalist[25344];
long AmplitudeMap[25344];

//̓_Qi[
double forexval[25344];
double foreyval[25344];
double forezval[25344];

int data_width, data_height;
int datanum = 0;

//ʂ̃p[^
double TableAverage[3];
double TableNormal[3];

//ʒup
CvPoint3D32f averageUpperSurface, vec1UpperSurface, vec2UpperSurface, vec3UpperSurface;
double distUpperSurface;


//̈ʒupp
//[N΍̂ObjectPoseEstimation2ServiceSVC_impl.cppŐ錾
//20111030
/*
static unsigned int **ObjectsMask;
int *ObjectsLabel = NULL;
*/

double objxval[25534];
double objyval[25534];
double objzval[25534];


//fobOp摜o͗p
double groval_xval[25534];
double groval_yval[25534];
double groval_zval[25534];

int large_region_num;
int box_count;
int cylinder_count;

int obj_count;

//䂪ݕ␳p
opencv::cvutil::Undistortor undistortor;

//̂̎ނ𔻕ʂ(͎gpĂȂ)
double offset = 0.0;

//wi菜߂̋臒l
extern float DistanceThresh;

extern bool isParameterLoaded;

extern IplImage *srcObjectImg;

extern int similar_direction(double nx1, double ny1, double nz1,
		      double nx2, double ny2, double nz2);
extern int similar_direction2(double nx1, double ny1, double nz1,
		      double nx2, double ny2, double nz2);
extern void calcNormal(CvPoint3D32f points[][SurfaceNormalWindowSize], CvPoint3D32f *normal);

extern void calcTablePlane(double *xval, double *yval, double *zval);

extern void calcSurfacePCA(CvPoint3D32f *average, CvPoint3D32f *vec1, CvPoint3D32f *vec2, CvPoint3D32f *vec3,
						   double *xval, double *yval, double *zval, int pointnum);

void ShowImageNX(const char *windowname, IplImage *img, int factor)
{
	int w, h;
	int width = img->width;
	int height = img->height;

	CvSize r_size = cvSize(width * factor, height * factor);
	IplImage *imgNX = cvCreateImage(r_size, IPL_DEPTH_8U, 1);

	for (h = 0; h < height*factor; h++)
	 for (w = 0; w < width*factor; w++){
		  SetIgray(imgNX, w, h, GetIgray(img, (int)(w/factor), (int)(h/factor)));
	 }

	cvShowImage(windowname, imgNX);
}

//ZT獂CCe_3W擾
void AcquireData(int *width, int *height, double **xval, double **yval, double **zval)
{
	*width = WIDTH_VALUE;
	*height = HEIGHT_VALUE;

	int bufsize = (*width) * (*height);

	*xval = (double *)calloc(bufsize, sizeof(double));
	*yval = (double *)calloc(bufsize, sizeof(double));
	*zval = (double *)calloc(bufsize, sizeof(double));

	for(int i = 0; i < bufsize; i++)
	{


		(*xval)[i] = RangeDatalist[i].x;
		(*yval)[i] = RangeDatalist[i].y;
		(*zval)[i] = RangeDatalist[i].z;

		//fobOp摜o͗p
		groval_xval[i] = RangeDatalist[i].x;
		groval_yval[i] = RangeDatalist[i].y;
		groval_zval[i] = RangeDatalist[i].z;

	}

	//䂪ݕ␳sĂ݂D

	CvMat *intrinsic = cvCreateMat (3, 3, CV_32FC1);
	CvMat *distortion = cvCreateMat (1, 4, CV_32FC1);

	intrinsic = (CvMat*)cvLoad("Intrinsics.xml");
	distortion = (CvMat*)cvLoad("Distortion.xml");

	undistortor.initialize((*width),(*height),cvmGet(intrinsic, 0,2), cvmGet(intrinsic, 1,2), cvmGet(intrinsic, 0,0),
		  cvmGet(intrinsic, 1, 1), cvmGet(distortion,0,0),cvmGet(distortion,0,1),cvmGet(distortion,0,2),cvmGet(distortion,0,3));

	opencv::cvutil::Image<IPL_DEPTH_64F> A( (*width), (*height), 3 );
	opencv::cvutil::Image<IPL_DEPTH_64F> B( (*width), (*height), 3 );

	A.clear();

	int ind;

	for( int v = 0; v < A.getHeight(); ++v )
	{
		for( int u = 0; u < A.getWidth(); ++u )
		{
			ind = v * (*width) + u;

			A(u,v,0) = (*xval)[ind], A(u,v,1) = (*yval)[ind], A(u,v,2) = (*zval)[ind];
//			printf("ind %d",ind);
		}
	}

	undistortor.process( A, B );

	for( int v = 0; v < B.getHeight(); ++v )
	{
		for( int u = 0; u < B.getWidth(); ++u )
		{
			ind = v * (*width) + u;
			(*xval)[ind] = B(u,v,0), (*yval)[ind] = B(u,v,1), (*zval)[ind]= B(u,v,2);
		}
	}
}
//---------------------------------------------------------------------------------------//

void ReadData(char *filename, int *width, int *height, double **xval, double **yval, double **zval)
{
	int w, h, ind;
	FILE *fp;
	errno_t err;

	if ((err = fopen_s(&fp, filename, "r")) != 0){
		fprintf(stderr, "file %s cannot be opened.\n", filename);
		exit(-1);
	}

	fscanf(fp, "%d %d\n", width, height);

	int bufsize = (*width) * (*height);

	*xval = (double *)calloc(bufsize, sizeof(double));
	*yval = (double *)calloc(bufsize, sizeof(double));
	*zval = (double *)calloc(bufsize, sizeof(double));

	for (h = 0; h < *height; h++){
		fprintf(stderr, "reading %d-th row..\n", h);
		for (w = 0; w < *width; w++){
			ind = h * (*width) + w;
			fscanf(fp, "%lf %lf %lf\n", &((*xval)[ind]), &((*yval)[ind]), &((*zval)[ind]));
		}
	}
	fclose(fp);
}

//---------------------------------------------------------------------------------------//
/*
 * 摜쐬
 */
IplImage *XYZtoImage(double *xval, double *yval, double *zval, int width, int height)
{
	unsigned char uval;
	int ind;
	double maxz = 0.0;

	// get maximum Z
	for (ind = 0; ind < width * height; ind++) maxz = max(maxz, zval[ind]);

	CvSize r_size = cvSize(width, height);
	IplImage *img = cvCreateImage(r_size, IPL_DEPTH_8U, 1);

	for (int h = 0; h < height; h++){
		for (int w = 0; w < width; w++){
			ind = h * width + w;
			uval = (unsigned char)(zval[ind] * 255.0 / (maxz + 0.1));
			SetIgray(img, w, h, uval);
		}
	}
	
	return img;
}

/*
 * ʒl摜쐬
 */
IplImage *ItoImage(long *amplitude, int width, int height)
{
	unsigned char uval;
	int ind;
	double maxz = 0.0;

	if(amplitude == NULL)
		printf("error");

	// get maximum Z
	for (ind = 0; ind < width * height; ind++) {
		maxz = max(maxz, (double)amplitude[ind]);
	}

	CvSize r_size = cvSize(width, height);
	IplImage *img = cvCreateImage(r_size, IPL_DEPTH_8U, 3);

	for (int h = 0; h < height; h++){
		for (int w = 0; w < width; w++){
			ind = h * width + w;
			uval = (unsigned char)((double)amplitude[ind] * 255.0 / (maxz + 0.1));
			SetIred(img, w, h, uval);
			SetIgreen(img, w, h, uval);
			SetIblue(img, w, h, uval);
		}
	}
	
	return img;
}

/*
 * 摜\
 */
void ShowData()
{
	static int window_opened = 0;

	fprintf(stderr, "show range data\n");

	double *xval, *yval, *zval;
	int w, h;

	//3_Q擾
	AcquireData(&w, &h, &xval, &yval, &zval);

	IplImage *img = XYZtoImage(xval, yval, zval, w, h);

	free(xval);
	free(yval);
	free(zval);

	if (! window_opened){
		cvNamedWindow("range data", 0);// open windows
		window_opened = 1;
	}

#if 0
	ShowImageNX("range data", img, 1);
#endif
#if 1
	cvShowImage("range data", img);

	cvWaitKey(10);
	cvSaveImage("rangedata.png", img);
#endif

	cvReleaseImage(&img);
}

//---------------------------------------------------------------------------------------//
/*
 * ZT̃Lu[V
 */
int CalibData()
{

	  CHESS_SIZE = Chess_size;
	  PAT_COL = Pat_col;
	  PAT_ROW = Pat_row;	
	  PAT_SIZE = PAT_COL * PAT_ROW;
	  ALL_POINTS = IMAGE_NUM * PAT_SIZE;

	  int i, j, k;
	  int corner_count, found;
	  int p_count[IMAGE_NUM];
	  CvSize pattern_size = cvSize (PAT_COL, PAT_ROW);
	  CvPoint3D32f *objects = (CvPoint3D32f *) cvAlloc (sizeof (CvPoint3D32f) * ALL_POINTS);
	  CvPoint2D32f *corners = (CvPoint2D32f *) cvAlloc (sizeof (CvPoint2D32f) * ALL_POINTS);
	  CvMat object_points;
	  CvMat image_points;
	  CvMat point_counts;
	  CvMat *intrinsic = cvCreateMat (3, 3, CV_32FC1);
	  CvMat *rotation = cvCreateMat (1, 3, CV_32FC1);
	  CvMat *translation = cvCreateMat (1, 3, CV_32FC1);
	  CvMat *distortion = cvCreateMat (1, 4, CV_32FC1);

	  int w, h;				//,
		
	  IplImage *img;

	  img = cvLoadImage("background.png");

	  cvNamedWindow ("Calibration", CV_WINDOW_AUTOSIZE);

#if 0
	  // (1)Lu[V摜̓ǂݍ
	  for (i = 0; i < IMAGE_NUM; i++) {
		char buf[32];
		sprintf (buf, "image%d.png", i);
		if ((src_img[i] = cvLoadImage(buf, CV_LOAD_IMAGE_COLOR)) == NULL) {
		  fprintf (stderr, "cannot load image file : %s\n", buf);
		}
	  }
#endif

	  // (2)3ԍW̐ݒ
	  for (i = 0; i < IMAGE_NUM; i++) {
		for (j = 0; j < PAT_ROW; j++) {
		  for (k = 0; k < PAT_COL; k++) {
			objects[i * PAT_SIZE + j * PAT_COL + k].x = j * CHESS_SIZE;
			objects[i * PAT_SIZE + j * PAT_COL + k].y = k * CHESS_SIZE;
			objects[i * PAT_SIZE + j * PAT_COL + k].z = 0.0;
		  }
		}
	  }
	  cvInitMatHeader (&object_points, ALL_POINTS, 3, CV_32FC1, objects);

	  // (3)`FX{[hiLu[Vp^[j̃R[i[o
	  int found_num = 0;

	  for (i = 0; i < IMAGE_NUM; i++) {
		 
		found = cvFindChessboardCorners (img, pattern_size, &corners[i * PAT_SIZE], &corner_count);
		fprintf (stderr, "%02d...", i);
		if (found) {
		  fprintf (stderr, "ok\n");
		  found_num++;
		}
		else {
		  fprintf (stderr, "fail\n");
		  cvDestroyWindow("Calibration");
		  return 1;
		}
		// (4)R[i[ʒuTusNZxɏCC`
		IplImage *src_gray = cvCreateImage (cvGetSize (img), IPL_DEPTH_8U, 1);
		cvCvtColor (img, src_gray, CV_BGR2GRAY);
		cvFindCornerSubPix (src_gray, &corners[i * PAT_SIZE], corner_count,
							cvSize (3, 3), cvSize (-1, -1), cvTermCriteria (CV_TERMCRIT_ITER | CV_TERMCRIT_EPS, 20, 0.03));

		cvDrawChessboardCorners (img, pattern_size, &corners[i * PAT_SIZE], corner_count, found);
		p_count[i] = corner_count;

		

		cvShowImage ("Calibration", img);

		if( corner_count == PAT_SIZE )
		{
			
			cvWaitKey ();

			isParameterLoaded = false;
		}
		else
		{
			cvWaitKey(300);
		}
		
	  }
		cvDestroyWindow ("Calibration");

//	  if (found_num != IMAGE_NUM)
//		return -1;

	  cvInitMatHeader (&image_points, ALL_POINTS, 1, CV_32FC2, corners);
	  cvInitMatHeader (&point_counts, IMAGE_NUM, 1, CV_32SC1, p_count);

#if 0
	  // (5)p[^Cc݌W̐
	  cvCalibrateCamera2 (&object_points, &image_points, &point_counts, cvSize (176, 144), intrinsic, distortion);


	  // (6)Op[^̐
	  CvMat sub_image_points, sub_object_points;
	  int base = 0;
	  //肵摜sub_image_points, sub_object_pointsɂD
	  cvGetRows (&image_points, &sub_image_points, base * PAT_SIZE, (base + 1) * PAT_SIZE);
	  cvGetRows (&object_points, &sub_object_points, base * PAT_SIZE, (base + 1) * PAT_SIZE);

#endif

	  intrinsic = (CvMat*)cvLoad("Intrinsics.xml");
	  distortion = (CvMat*)cvLoad("Distortion.xml");

	  if(intrinsic == NULL)
	  {
		  printf("prease prepare Intrinsics.xml\n");
		  return 1;
	  }

	  if(distortion == NULL)
	  {
		  printf("prease prepare Distortion.xml\n");
		  return 1;
	  }

	  cvFindExtrinsicCameraParams2 (&object_points, &image_points, intrinsic, distortion, rotation, translation);
		
	  if( corner_count == PAT_SIZE )
		{
			
			cvSave("Rotation.xml",rotation);
			cvSave("Translation.xml",translation);
		}

	  // (7)XMLt@Cւ̏o

	  cvReleaseImage(&img);

	 //̊J

	  cvFree(&objects);
	  cvFree(&corners);

	  cvReleaseMat(&intrinsic);
	  cvReleaseMat(&rotation);
	  cvReleaseMat(&translation);
	  cvReleaseMat(&distortion);

	  return 0;
}
//---------------------------------------------------------------------------------------//
// DumpData: Acquire and dump range data to file
//   calls: AcquireData, DumpXYZ
void DumpData()
{
	fprintf(stderr, "dump range data\n");

	char filename[80];

	printf(" input file name to dump: ");
	fflush(stdout);
	scanf("%s", filename);

	double *xval, *yval, *zval;
	int w, h;

	AcquireData(&w, &h, &xval, &yval, &zval);
//	ReadData("box.txt",&w, &h, &xval, &yval, &zval);

	DumpXYZ(filename, xval, yval, zval, w, h);

	free(xval);
	free(yval);
	free(zval);
}

// DumpXYZ: Dump Raw Range Data in XYZ to a file
int DumpXYZ(char *filename, double *xval, double *yval, double *zval, int width, int height)
{
	int w, h, ind;
	FILE *fp;
	errno_t err;

	if ((err = fopen_s(&fp, filename, "w")) != 0){
		fprintf(stderr, "file %s cannot be opened.\n", filename);
		exit(-1);
	}

	fprintf(fp, "%d %d\n", width, height);
	for (h = 0; h < height; h++){
		fprintf(stderr, "saving %d-th row..\n", h);
		for (w = 0; w < width; w++){
			ind = h * width + w;
			fprintf(fp, "%f %f %f\n",xval[ind], yval[ind], zval[ind]);
		}
	}
	fclose(fp);

	return 0;
}

// PartialDumpXYZ: Dump a part of raw range data in XYZ to a file
int PartialDumpXYZ(char *filename, double *xval, double *yval, double *zval, int size, int effective_size, unsigned int *mask)
{
	int i;
	FILE *fp;
	errno_t err;

	if ((err = fopen_s(&fp, filename, "w")) != 0){
		fprintf(stderr, "file %s cannot be opened.\n", filename);
		exit(-1);
	}

	fprintf(fp, "%d\n", effective_size);
	for (i = 0; i < size; i++){
		if (mask[i]) fprintf(fp, "%f %f %f\n", xval[i], yval[i], zval[i]);
	}

	fclose(fp);

	return 0;
}

//---------------------------------------------------------------------------------------//

//ς߂
double DotProduct(CvPoint3D32f v1, CvPoint3D32f v2){
	return(v1.x * v2.x + v1.y * v2.y + v1.z * v2.z);
}

/*
 * wi_Q擾
 */
// GetBackgroundData: Acquire data and keep them
//   calls: AcquireData
void GetBackgroundData(int readBgData)
{
	fprintf(stderr, "get background range data\n");

	double *xval, *yval, *zval;
	int w, h;

	if (readBgData){
		ReadData("background.dat", &w, &h, &xval, &yval, &zval);
	}
	else{
		printf("acquire data\n");
		AcquireData(&w, &h, &xval, &yval, &zval);
		
	}

	//ʂ̕vZ
	calcTablePlane(xval, yval, zval);

	//J
	free(xval);
	free(yval);
	free(zval);
}

//--------------------------------------------------------------------------------------//

// FindObject: find a specified object in the range data
//   calls: AcquireData, ...


#define ForeBackThresh	0.01 // 1cm
/*
 * 摜1f̖@vZ
 * ډf̎ӂ̋l蕽ʂ`A
 * PCAɂ邱ƂɂvZ
 */
CvPoint3D32f calcNormalofaPoint(int h, int w, double *xval, double *yval, double *zval)
{
	CvPoint3D32f normal;
	CvPoint3D32f surface_region[SurfaceNormalWindowSize][SurfaceNormalWindowSize];

	int ind, indd;

	ind = h * data_width + w;

	for (int hh = -HalfSurfaceNormalWindowSize; hh <= HalfSurfaceNormalWindowSize; hh++){
		for (int ww = -HalfSurfaceNormalWindowSize; ww <= HalfSurfaceNormalWindowSize; ww++){
			indd = ind + hh * data_width + ww;
//			printf("hh %d ww %d\n",hh,ww);
//			printf("indd %d\n",indd);

			surface_region[hh+HalfSurfaceNormalWindowSize][ww+HalfSurfaceNormalWindowSize].x = xval[indd]; 
			surface_region[hh+HalfSurfaceNormalWindowSize][ww+HalfSurfaceNormalWindowSize].y = yval[indd]; 
			surface_region[hh+HalfSurfaceNormalWindowSize][ww+HalfSurfaceNormalWindowSize].z = zval[indd]; 
		}
	}

	calcNormal(surface_region, &normal);	


	return normal;
}

/*
	Ŝ̓_Q̒畨̂ł_QoD
	1Cs0ԂD
*/
int FindVarietyObjects_with_plane(unsigned int **ObjectsMask, std::vector<int> *ObjectsLabel)
{
	//EBhE͊JȂ
	static int fore_window_opened = 1;

	fprintf(stderr, "find obejct\n");
/*
	//fobOp_Qo
	std::ofstream ofs;	
	ofs.open("labeld_obj_result_estimate_plane.txt",std::ios::out);
*/

	//t@C
	std::ifstream ifs("planeparameter.txt");
	std::string str;
	char line[100], *ptr;
	double buf[6];
	int i = 0;

	if (ifs.fail())
	{
		fprintf(stderr, "Could not open desk plane parameter file -> planeparameter.txt \n");
		return 0;
	}

	//t@Cǂݍ
	while(ifs.getline(line, 100) != NULL)
	{
		std::cout << line << std::endl;
		ptr = line;
		do{
			buf[i] = atof(ptr);
			ptr = strchr(ptr, ',');
			if(ptr!=NULL) {ptr++;}
			i++;

		}while(ptr!=NULL);
	}

	for(i = 0; i < 3; i++)
	{
		TableAverage[i] = buf[i];
	}
	for(i = 0; i < 3; i++)
	{
		TableNormal[i] = buf[i + 3];
	}

	double	*xval, *yval, *zval;

	int		w, h, width, height, ind, size;
	int		fgnum = 0;
	point p;

	AcquireData(&width, &height, &xval, &yval, &zval);
	size = width * height;

	data_width = width;
	data_height = height;

    // show forefround image

	IplImage *img = XYZtoImage(xval, yval, zval, width, height);
	
	unsigned int indmask[HEIGHT_VALUE * WIDTH_VALUE];

	if (! fore_window_opened){
		cvNamedWindow("foreground data", 0);// open window
	}

	CvPoint3D32f pointdatanormal;
	double dotp;

	//摜ǂݍ
	IplImage *notCalcMaskImg;
	notCalcMaskImg = cvLoadImage("notCalc.bmp",CV_LOAD_IMAGE_GRAYSCALE);

	for (h = 0; h < height; h++){
		for (w = 0; w < width; w++){

			ind = h * width + w;
			p.x = xval[ind];
			p.y = yval[ind];
			p.z = zval[ind];
			//vZȂꏊ̃}XN摜ǂݍ
			//̉f0Ƃ̂
 			if(notCalcMaskImg->imageData[ind] == 0)
 			{
 				SetIgray(img, w, h, (unsigned char)255);
 				ObjectsMask[h][w] = FMIN;
 				indmask[ind] = 0;
 			}
 			else if (zval[ind] > DistanceThresh){ //s臒lȏゾ菜
				SetIgray(img, w, h, (unsigned char)255);
				ObjectsMask[h][w] = FMIN;
				indmask[ind] = 0;
			}
			else if (polygon_point_distance_for_find_object(TableAverage, TableNormal, &p) < ForeBackThresh)
			{
				//ʂ̋1cmȓ
				if(h >= HalfSurfaceNormalWindowSize && h < (data_height - HalfSurfaceNormalWindowSize) 
					&& w >= HalfSurfaceNormalWindowSize && w < (data_width - HalfSurfaceNormalWindowSize))
				{
					pointdatanormal = calcNormalofaPoint(h, w, xval, yval, zval);

					dotp = pointdatanormal.x * TableNormal[0] + pointdatanormal.y * TableNormal[1] + pointdatanormal.z * TableNormal[2];
					
					if(similar_direction2(pointdatanormal.x, pointdatanormal.y, pointdatanormal.z, 
						TableNormal[0], TableNormal[1], TableNormal[2]))
					{
						//@̖@Ɠ菜
						SetIgray(img, w, h, (unsigned char)255);
						ObjectsMask[h][w] = FMIN;
						indmask[ind] = 0;
					}
					else
					{
						ObjectsMask[h][w] = FMAX;
						indmask[ind] = 1;
//							ofs << xval[ind] << ' ' << yval[ind] << ' ' << zval[ind] << std::endl;
					}
				}
				else
				{
					SetIgray(img, w, h, (unsigned char)255);
					ObjectsMask[h][w] = FMIN;
					indmask[ind] = 0;
				}
			}
			else{
				ObjectsMask[h][w] = FMAX;
				indmask[ind] = 1;
//				ofs << xval[ind] << ' ' << yval[ind] << ' ' << zval[ind] << std::endl;

			}
		}
	}
	
	cvReleaseImage(&notCalcMaskImg);


	// extract the maximum region (using labeling)

	// the boundary should be the background!
	for (h = 0; h < height; h++){
		ObjectsMask[h][0] = FMIN;
		ObjectsMask[h][width-1] = FMIN;
	}
	for (w = 0; w < width; w++){
		ObjectsMask[0][w] = FMIN;
		ObjectsMask[height-1][w] = FMIN;
	}

//for debug

#ifdef DEBUG
	cvShowImage("foreground data", img);
	cvWaitKey(500);
#endif

	//܂łŁĈ̉摜ł

	int region_num = labeling(ObjectsMask, width, height);
	printf("region_num %d\n",region_num);

//	getchar();

	//Ȗʐς̈D

	std::vector<int> sizes;

	sizes.resize( region_num+1, 0);

	large_region_num = 0;

	for (h = 0; h < height; h++){
		for (w = 0; w < width; w++){
			if (ObjectsMask[h][w] > FMIN){
				sizes.at(ObjectsMask[h][w])++;
			}
		}
	}
	for (int r = 1; r <= region_num; r++){
		printf("%d size : %d\n",r, sizes[r]);
		if (sizes[r] >= 400){
			//400pixelȏゾCc
			large_region_num++;
		}
	}

	printf("large_region_num:%d\n",large_region_num);

	//傫̈xi[
	int count = 0;

	for (int r = 1; r <= region_num; r++){
		printf("%d size : %d\n",r, sizes[r]);
		if (sizes[r] >= 400){
			//400pixelȏゾCc
			ObjectsLabel->push_back(r);
		}
	}

	// reserve only data for the largest region
	// modify mask at the same time (background = FMIN)

	int no_object = 1;

	//傫̈ȊO₩珜
	for (h = 0; h < height; h++){
		for (w = 0; w < width; w++){
			ind = h * width + w;
			for(int i = 0; i < large_region_num; i++)
			{
				if (ObjectsMask[h][w] == (*ObjectsLabel)[i]){
					fgnum++;
					no_object = 0;
					break;
				}
			}
			if(no_object){
				SetIgray(img, w, h, (unsigned char)255);
				zval[ind] = BACKGROUND_DEPTH;// Set a specific value to background pixels in range data.
				ObjectsMask[h][w] = FMIN;
				indmask[ind] = 0;
			}
		}
	}

	for(h = 0; h < height; h++)
	{
		for(w = 0; w < width; w++)
		{
			ind = h * width + w;

			objxval[ind] = xval[ind];
			objyval[ind] = yval[ind];
			objzval[ind] = zval[ind];
		}
	}

	fprintf(stderr, "number of foreground data = %d\n", fgnum);

	//fgnum0 -> Ώە
	if(fgnum == 0)
	{
		fprintf(stderr, "Could not find object.\n");
		return 0;
	}

#ifdef DEBUG
	cvShowImage("foreground data", img);

//	cvWaitKey(1000);
	cvWaitKey(200);
#endif
	//̌ƂȂ镨̗݂̂̈̂c摜̐
	CvSize r_size2 = cvSize(data_width * AMP_NUM, data_height * AMP_NUM);
	IplImage *img2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

  for (h = 0; h < data_height*AMP_NUM; h++)
	for (w = 0; w < data_width*AMP_NUM; w++){
	  SetIgray(img2, w, h, GetIgray(img, (int)(w/AMP_NUM), (int)(h/AMP_NUM)));
	}

	cvCopy(img2, srcObjectImg);

	cvSaveImage("all foreground data.png", img);
	cvReleaseImage(&img);
	cvReleaseImage(&img2);
/*
*/	//for debug
	//EBhE͊JȂ
	if (! fore_window_opened)
		cvDestroyWindow("foreground data");
	
#if 0
	// dump foreground data
	DumpXYZ("foreground.dat", xval, yval, zval, width, height);
#endif

	//J
	free(xval);
	free(yval);
	free(zval);

	for(int i = 0; i < large_region_num; i++)
		printf("ObjectsLabel[%d]:%d",i,(*ObjectsLabel)[i]);

	return 1;
}

double calcdist(double x1, double y1, double x2, double y2)
{
	return sqrt(((x1 - x2) * (x1 - x2)) + ((y1 - y2) * (y1 - y2)));
}
/*
 * ̂̏ʂ̍vZ
 * ʒǔvZɗp
 */
int CalcObjectUpperSurface(int label, unsigned int **ObjectsMask, std::vector<int> ObjectsLabel)
{

	//EBhE͊JȂ
	static int fore_window_opened = 1;

	int		w, h, width, height, ind, size;
	int		fgnum = 0;
	point p;

    width = WIDTH_VALUE;
	height = HEIGHT_VALUE;

	size = width * height;

	data_width = width;
	data_height = height;

	unsigned int **maskNormal = BNew(unsigned int, height, width);
	unsigned int indmask[HEIGHT_VALUE * WIDTH_VALUE];

	if (! fore_window_opened){
		cvNamedWindow("normal image", 0);
		cvNamedWindow("foreground data", CV_WINDOW_AUTOSIZE);// open windows, window size is adjusted to that of the image.
	}

	CvPoint3D32f pointdatanormal;

	
	IplImage *imgNormal;
	
	printf("start calcObjectUpperSurface\n");
	printf("label:%d\n",label);

	imgNormal = cvCreateImage(cvSize(data_width, data_height), IPL_DEPTH_8U, 1);

	//̂uĂԂ3_Q̂܂܃Rs[
	double xval[WIDTH_VALUE * HEIGHT_VALUE];
	double yval[WIDTH_VALUE * HEIGHT_VALUE];
	double zval[WIDTH_VALUE * HEIGHT_VALUE];

	for (h = 0; h < height; h++)
	{
		for ( w = 0; w < width; w++)
		{
			ind = h * width + w;
			xval[ind] = objxval[ind];
			yval[ind] = objyval[ind];
			zval[ind] = objzval[ind];
		}
	}

	IplImage *img = XYZtoImage(xval, yval, zval, width, height);

	//for debug 1024
	int maskNormal_FMAXcount = 0;

	for (h = 0; h < height; h++){
		for (w = 0; w < width; w++){

			SetIgray(imgNormal, w, h, (unsigned char)255);
			maskNormal[h][w] = FMIN;

			ind = h * width + w;

			if(ObjectsMask[h][w] == ObjectsLabel[label])
			{
				p.x = xval[ind];
				p.y = yval[ind];
				p.z = zval[ind];

				if (polygon_point_distance_for_find_object(TableAverage, TableNormal, &p) < ForeBackThresh)
				{
				}
				else{
					//ʂƂ̋1cmȏ
					indmask[ind] = 1;

					if(h >= HalfSurfaceNormalWindowSize && h < (data_height - HalfSurfaceNormalWindowSize) 
						&& w >= HalfSurfaceNormalWindowSize && w < (data_width - HalfSurfaceNormalWindowSize))
					{
						pointdatanormal = calcNormalofaPoint(h, w, xval, yval, zval);

						if(similar_direction2(pointdatanormal.x, pointdatanormal.y, pointdatanormal.z, 
							TableNormal[0], TableNormal[1], TableNormal[2]))
						{
							//ʂƖ@
							SetIgray(imgNormal, w, h, (unsigned char)0);
							maskNormal[h][w] = FMAX;
							maskNormal_FMAXcount++;
						}
					}
				}
			}
			else
			{
				indmask[ind] = 0;
			}
		}
	}

	//for debug
#ifdef DEBUG
/*
	cvShowImage("foreground data", img);

	cvWaitKey(100);

	cvShowImage("normal image", imgNormal);

	cvWaitKey(100);
*/
#endif	

	//̖ʂ̃xO
	int region_num_normal = labeling(maskNormal, width, height);

	printf("region_num_normal : %d\n",region_num_normal);

	int largest_region_id_normal = find_largest_region(region_num_normal, maskNormal, width, height);

	printf("largest_region_id_normal : %d\n",largest_region_id_normal);

	int countNormal = 0;
	distUpperSurface = 0.0;
	int i = 0;

	for (h = 0; h < height; h++){
		for (w = 0; w < width; w++){
			ind = h * width + w;
			if (maskNormal[h][w] == largest_region_id_normal){
				p.x = xval[ind];
				p.y = yval[ind];
				p.z = zval[ind];
				distUpperSurface += polygon_point_distance_for_find_object(TableAverage, TableNormal, &p);
				countNormal++;
			}
			else{
			}
		}
	}

	printf("distUpperSurface : %3.3f\n",distUpperSurface);
	printf("countNormal : %d\n",countNormal);

	distUpperSurface /= (double)countNormal;


	printf("distNormal : %3.3f\n",distUpperSurface);

	double *xvalUpper = CNew(double, countNormal);
	double *yvalUpper = CNew(double, countNormal);
	double *zvalUpper = CNew(double, countNormal);

	for(h = 0; h < height; h++)
	{
		for(w = 0; w < width; w++)
		{
			ind = h * width + w;
			if (maskNormal[h][w] == largest_region_id_normal){
				xvalUpper[i] = xval[ind];
				yvalUpper[i] = yval[ind];
				zvalUpper[i] = zval[ind];
				i++;
			}
			else{
			}
		}
	}

	calcSurfacePCA(&averageUpperSurface, &vec1UpperSurface, &vec2UpperSurface, &vec3UpperSurface,
		xvalUpper, yvalUpper, zvalUpper, countNormal);

	printf("averageUpperSurface(%3.3f, %3.3f, %3.3f)\n",averageUpperSurface.x, averageUpperSurface.y, averageUpperSurface.z);
	printf("vec1(%3.3f, %3.3f, %3.3f)\n",vec1UpperSurface.x, vec1UpperSurface.y, vec1UpperSurface.z);
	printf("vec2(%3.3f, %3.3f, %3.3f)\n",vec2UpperSurface.x, vec2UpperSurface.y, vec2UpperSurface.z);
	printf("vec3(%3.3f, %3.3f, %3.3f)\n",vec3UpperSurface.x, vec3UpperSurface.y, vec3UpperSurface.z);

	// reserve only data for the largest region
	// modify mask at the same time (background = FMIN)

	for (h = 0; h < height; h++){
		for (w = 0; w < width; w++){
			ind = h * width + w;

			if(ObjectsMask[h][w] != ObjectsLabel[label]){
				SetIgray(img, w, h, (unsigned char)255);
				zval[ind] = BACKGROUND_DEPTH;// Set a specific value to background pixels in range data.

				indmask[ind] = 0;
			}
			else{
				fgnum++;
			}
		}
	}

	for(h = 0; h < height; h++){
		for(w = 0; w < width; w++){

			ind = h * width + w;
			forexval[ind] = xval[ind];
			foreyval[ind] = yval[ind];
			forezval[ind] = zval[ind];
		}
	}

	fprintf(stderr, "number of foreground data = %d\n", fgnum);
//	ofs.close();

	//fgnum0 -> Ώە
	if(fgnum == 0)
	{
		fprintf(stderr, "Could not find object.\n");
		return 0;
	}

	//for debug
#ifdef DEBUG

	cvShowImage("foreground data", img);

	cvWaitKey(0);


	cvSaveImage("foreground data.png", img);
	cvSaveImage("normal image.png", imgNormal);

#endif

	cvReleaseImage(&img);
	cvReleaseImage(&imgNormal);
	
	//for debug
	if (! fore_window_opened){
		cvDestroyWindow("foreground data");
		cvDestroyWindow("normal image");
	}
#if 0
	// dump foreground data
	DumpXYZ("foreground.dat", xval, yval, zval, width, height);
#endif

	for(int i = 0; i < height; i++)
		free(maskNormal[i]);

	free(maskNormal);
	
	free(xvalUpper);
	free(yvalUpper);
	free(zvalUpper);

	return 0;
}

void DumpForegroundData()
{
	fprintf(stderr, "dump foreground data\n");

	char filename[80];

	if (forexval == NULL){
		fprintf(stderr, " Get Foreground Data first.\n");
	}

	printf(" input file name to dump: ");
	fflush(stdout);
	scanf("%s", filename);

	DumpXYZ(filename, forexval, foreyval, forezval, data_width, data_height);
}

void ReadObjectData()
{
	fprintf(stderr, "get foreground range data\n");

	double *xval, *yval, *zval;
	int w, h;
	char filename[80];

	printf(" input object file name to read: ");
	fflush(stdout);
	scanf("%s", filename);

	if (filename){
		ReadData(filename, &w, &h, &xval, &yval, &zval);

		data_width = w;
		data_height = h;
	}

	// Do not free data (ketp by back*val pointers)
//	free(xval);
//	free(yval);
//	free(zval);
}